---
title: Parsica
sidebar_label: About Parsica
---

The easiest way to build robust parsers in PHP.

**Note:** Parsica is very early stage, expect things to break. 

* [Installation & Requirements](installation)
* [API Reference](api/index)

## Tutorial

1. [What are parser combinators?](tutorial/introduction)
1. [Building Blocks](tutorial/building_blocks)
1. [Running Parsers](tutorial/running_parsers)
1. [Mapping to Objects](tutorial/mapping_to_objects)
1. [Order Matters](tutorial/order_matters)
1. [Recursion](tutorial/recursion)
1. [Look Ahead](tutorial/look_ahead)

## Resources

* [Development Status](resources/development_status)
* [Performance](resources/performance)
* [Naming Conventions](resources/naming_conventions)
* [Functional Paradigms](resources/functional_paradigms)

## Contribute

* [Donate via Paypal](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=NS4GQXUDXRKQJ&source=url). This project was researched and created entirely during unpaid time. Your contribution helps us with continued development.
* [Design Goals](contribute/design_goals)
* Contribute by submitting code, documentation, examples, ... through pull requests.
* [Code of Conduct](CODE_OF_CONDUCT)

## Support

### Commercial training & support

E-mail [contact@value-object.com](contact@value-object.com).

### Community support

Submit questions as Github issues. Please label them with 'support'. Help us help you by submitting short bits of code that demonstrate the problem, and that can easily be copied and run. 

## Links

* Official Site: [parsica.verraes.net](https://parsica.verraes.net)
* Twitter: [@parsica_php](https://twitter.com/parsica_php)
* GitHub: [mathiasverraes/parsica](https://github.com/mathiasverraes/parsica)
* Packagist: [mathiasverraes/parsica](https://packagist.org/packages/mathiasverraes/parsica)
* License: [MIT](LICENSE)
* Donate: [Paypal](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=NS4GQXUDXRKQJ&source=url)
